<SCRIPT LANGUAGE="VBScript">

Const cdoRunNextSink = 0
Const cdoSkipRemainingSinks = 1
Const cdoStatAbortDelivery = 2

'Set ldr = CreateObject("CDOLoader.CDOMessageLoader")
'Set message = Ldr.LoadMessage("Test2.eml")
'WScript.Echo msg.Attachments.Count
'ISMTPOnArrival_OnArrival message, 0


Sub IEventIsCacheable_IsCacheable()
 ' just returns S_OK
End Sub

Sub ISMTPOnArrival_OnArrival(ByVal iMsg, EventStatus)
  if ProcessMessage (imsg) then
      Set Flds = iMsg.EnvelopeFields
      Flds("http://schemas.microsoft.com/cdo/smtpenvelope/messagestatus")=cdoStatAbortDelivery
      Flds.Update
	  EventStatus = cdoSkipRemainingSinks
  else
	  EventStatus = cdoRunNextSink
  end if
End Sub


Function ProcessMessage(Msg)

ProcessMessage = false

Set sh = CreateObject("WScript.Shell")
sh.LogEvent 0, "Inside sink"
on error resume next
catchall = sh.RegRead("HKLM\Software\Microsoft\POP3 Service\Catch-all account")
if err.number <> 0 then
	sh.LogEvent 4, "Catch-all account is not configured"
	Exit Function
end if
'on error goto 0

bNdr = false
'sh.LogEvent 0, msg.BodyPart.BodyParts.Count
for each part in msg.BodyPart.BodyParts
        'if part is null then exit for
	sh.LogEvent 0, part.ContentMediaType
	if part.ContentMediaType = "message/delivery-status" then
		for each fld in ExtractMessage(part).Fields
			sh.LogEvent 0, fld.Name & ":: " & fld.value
		next
		stat = GetStatus(part)
		sh.LogEvent 0,  "Status = " & stat
		bNDR = stat = "5.0.0"
	end if
	if part.ContentMediaType = "message/rfc822" and bNDR then
		s = GetMailFile(catchall)
		sh.LogEvent 0,  "Save to " & s
		part.SaveToFile s
		ProcessMessage = true
	end if
	if part.ContentMediaType = "application/octet-stream" then 'Executable attachment
		ProcessMessage = true
		Exit Function
	end if
next

end Function

Function ExtractMessage(iBp) 
    Dim iMsg
    Set iMsg = CreateObject("CDO.Message")
    Dim iDsrc
    Set iDsrc = iMsg.DataSource
    iDsrc.OpenObject iBp, "IBodyPart"
    Set ExtractMessage = iMsg
End Function


function GetStatus(iBp)
	set fld = ExtractMessage(iBp).Fields("urn:schemas:httpmail:textdescription")
	arr = Split(fld.value, vbCrLf)
	for i = LBound(arr) to UBound(arr)
		item = Split(arr(i), ": ")
		if item(0) = "Status" then 
			GetStatus = item(1)
			Exit function
		end if
	next
end function


function GetCatchallFolder(ac)
	set cfg = CreateObject("P3Admin.p3Config")
	MailRoot = cfg.mailRoot
	name = Split(ac, "@")(0)
	domain = Split(ac, "@")(1)
	GetCatchallFolder = MailRoot & "\" & domain & "\P3_" & name & ".mbx"
end function

function GetMailFile(ac)
	folder = GetCatchallFolder(ac) & "\"
	set fso = CreateObject("Scripting.FileSystemObject")
	i = 1
	do until not fso.FileExists(Folder & BuildFileName("P3_", i) & ".eml")
		i = i + 1
	loop
	GetMailFile = Folder & BuildFileName ("P3_", i) & ".eml"
end function

function BuildFileName(prefix, val)
	BuildFileName = prefix & Year(Now) & Month(Now) & Day(Now) & Hour(Now) & Minute(Now) & Second(Now) & CStr(int(Timer)) & val
end function












</SCRIPT>
