if  WScript.Arguments.Count <> 1 then
	WScript.Echo "Usage: cscript configure.vbs <catchall account name>"
	WScript.Echo "E.g. cscript configure.vbs bob@domain.com"
	WScript.Quit
end if

catchall = WScript.Arguments(0)
set srv=GetObject("IIS://localhost/smtpsvc/1")
pmemail = srv.PostMasterEmail
if pmemail = "" then pmemail = "postmaster@" & srv.DefaultDomain

'WScript.Echo pmemail 

set cfg = CreateObject("P3Admin.P3Config")
username = Split(WScript.Arguments(0), "@")(0)
domainname = Split(WScript.Arguments(0), "@")(1)

IsValiduser = false
on error resume next
set domain = cfg.Domains.Item(domainname)
if Err.Number = 0  then
	for each u in domain.Users
		if u.Name = username then IsValiduser = true
	next
else
	'WScript.Echo Err.Description
end if

if not IsValiduser then
	WScript.Echo "Account " & WScript.Arguments(0) & " was not found. Please specify a valid account"
	WScript.Quit
end if


on error goto 0

Set fso = CreateObject("Scripting.FileSystemObject")

scriptpath = FSO.getAbsolutePathName("catchall.vbs")

set f = fso.CreateTextFile("regsink.cmd")
f.WriteLine "cscript smtpreg.vbs /remove 1 onarrival CatchAll"
'f.WriteLine "cscript smtpreg.vbs /add     1 onarrival CatchAll CDO.SS_SMTPOnArrivalSink ""mail from=" & pmemail & """"
f.WriteLine "cscript smtpreg.vbs /add     1 onarrival CatchAll CDO.SS_SMTPOnArrivalSink ""mail from=*"""
f.WriteLine "cscript smtpreg.vbs /setprop 1 onarrival CatchAll Sink ScriptName """ & scriptpath & """"
f.WriteLine "cscript smtpreg.vbs /setprop 1 onarrival CatchAll Source Priority ""10"""

f.Close

set sh = CreateObject("WScript.Shell")
sh.Run "regsink.cmd"

sh.RegWrite "HKLM\Software\Microsoft\POP3 Service\Catch-all account", catchall